#include "MonochromeLib.h"
#include "fxlib.h"
#include "stdio.h"

extern Zelda[100];
extern Coeur;
extern Map[22][30];
extern MapInf[8];

const unsigned char Fairy0[]={0x0, 0x0, 0x0, 0x0, 0x30, 0xc, 0x28, 0x14, 0x24, 0x24, 0x24, 0x24, 0x22, 0x44, 0x13, 0xcc, 0xe, 0x78, 0xc, 0x30, 0xc, 0x30, 0x16, 0x68, 0x27, 0xe4, 0x3c, 0x3c, 0x0, 0x0, 0x0, 0x0, };
const unsigned char Fairy1[]={0x0, 0x0, 0x0, 0x0, 0xf0, 0xf, 0x8c, 0x31, 0x83, 0xc1, 0x46, 0x62, 0x3c, 0x3c, 0x4, 0x20, 0x6, 0x60, 0xb, 0xd0, 0xa, 0x50, 0xa, 0x50, 0x6, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, };

const unsigned char ZoneTexte[]={0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe};
int AfficherStats()
	{
	char X;
	char Y;
	char VariableA;
	unsigned char *dia;
	const unsigned char diamants[]={0x1e, 0x0, 0x0, 0x3f, 0x2a, 0x3f, 0xff, 0xbf, 0x46, 0x60, 0x0, 0xff, 0xca, 0x40, 0x0, 0x7f, 0xbc, 0x40, 0x0, 0x7f, 0xd8, 0x40, 0x0, 0x7f, 0xf0, 0x40, 0x0, 0x7f, 0x0, 0x40, 0x0, 0x7f, 0x78, 0x60, 0x0, 0xff, 0xfc, 0x3f, 0xff, 0xbf, 0x78, 0x0, 0x0, 0x3f};
	const unsigned char diamants2[]={0xff, 0xff, 0xff, 0xff, 0xeb, 0xff, 0xff, 0xff, 0xc7, 0xe0, 0x0, 0xff, 0xcb, 0xc0, 0x0, 0x7f, 0xbf, 0xc0, 0x0, 0x7f, 0xdf, 0xc0, 0x0, 0x7f, 0xff, 0xc0, 0x0, 0x7f, 0xff, 0xc0, 0x0, 0x7f, 0xff, 0xe0, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
	const unsigned char coeurs[]={0x6d, 0xbf, 0xff, 0x7d, 0x39, 0x11};
	const unsigned char coeurs2[]={0xff, 0xbf, 0xff, 0xff, 0xff, 0xff};
	ML_bmp_and(diamants2,100,3,26,11);
	ML_bmp_or(diamants,100,3,26,11);
	for(VariableA=1; VariableA!=Coeur+1; VariableA++)
		{
		switch(VariableA)
			{
			case 1: X=3; Y=3; break;
			case 2: X=11; Y=3; break;
			case 3: X=19; Y=3; break;
			case 4: X=27; Y=3; break;
			case 5: X=35; Y=3; break;
			case 6: X=3; Y=10; break;
			case 7: X=11; Y=10; break;
			case 8: X=19; Y=10; break;
			case 9: X=27; Y=10; break;
			case 10: X=35; Y=10; break;
			case 11: X=3; Y=17; break;
			case 12: X=11; Y=17; break;
			case 13: X=19; Y=17; break;
			case 14: X=27; Y=17; break;
			case 15: X=35; Y=17; break;
			}
		ML_bmp_and(coeurs2,X,Y,7,6);
		ML_bmp_or(coeurs,X,Y,7,6);
		ML_pixel(X+1, Y+1, 0);
		}
	if(Zelda[5]>Zelda[6]){Zelda[5]=Zelda[6];}
	sprintf(dia,(unsigned char*)"%d",Zelda[5]);
	PrintMini(112,6,(unsigned char *)dia,1);
	}
Dialogue(di1,di2)
	{
	NoShift();
	ML_bmp_or(ZoneTexte,0,48,128,16);
	ML_bmp_and(ZoneTexte,0,48,128,16);
	PrintMini(3,50,(unsigned char *)di1,1);
	PrintMini(3,56,(unsigned char *)di2,1);
	ML_display_vram();
	Shift();
	NoShift();
	}

DialogueNoShift(di1,di2)
	{
	ML_bmp_or(ZoneTexte,0,48,128,16);
	ML_bmp_and(ZoneTexte,0,48,128,16);
	PrintMini(3,50,(unsigned char *)di1,1);
	PrintMini(3,56,(unsigned char *)di2,1);
	}

int  Options()
	{
	char X=22;
	char Y;
	char Vitesse=Zelda[0];
	char VarA=0;
	char Langue=Zelda[7];
	char NivGris=Zelda[8];
	Zelda[0]=2;
	if(!Vitesse){Vitesse=1;}
	while(!key_down(78))
		{
		setFps(20);
		Clear();
		switch(Langue)
			{case 1: DialogueNoShift("Link !","Choisis ta langue."); break;
			case 0: DialogueNoShift("Link !","Choose your language."); break;
			case 2: DialogueNoShift("Link !","Wahlen Sie Ihre Sprache."); break;
			case 3: DialogueNoShift("Link !","Elija su idioma."); break;} 
		PrintMini(50,10,"English",0);
		PrintMini(50,18,"Francais",0);
		PrintMini(50,26,"Deutsch",0);
		PrintMini(50,34,"Espanol",0);
		switch(Langue)
			{
			case 0: Y=4; break;
			case 1: Y=12; break;
			case 2: Y=20; break;
			case 3: Y=28; break;
			}
		if(VarA==1)
			{ML_bmp_16_or(Fairy0,X,Y); ML_bmp_16_or(Fairy0,X+68,Y); VarA=0;}
		else
			{ML_bmp_16_or(Fairy1,X,Y); ML_bmp_16_or(Fairy1,X+68,Y); VarA++;}
		ML_display_vram();
		if(key_down(28)&Langue!=0){Langue--; while(key_down(28));}
		if(key_down(37)&Langue!=3){Langue++; while(key_down(37));}
		}
	Zelda[7]=Langue;
	
	
	while(key_down(78));
	while(!key_down(78))
		{
		setFps(20);
		Clear();
		switch(Zelda[7])
			{case 1:
			DialogueNoShift("Link ! Veux-tu activer","le niveau de gris ?"); 
			PrintMini(55,18,"Non",0);
			PrintMini(55,26,"Oui",0); break;
			case 0:
			DialogueNoShift("Link ! Do you want to","activate the gray level ?"); 
			PrintMini(55,18,"No",0);
			PrintMini(55,26,"Yes",0); break;
			case 2:
			DialogueNoShift("Link ! Wollen Sie die","Graustufen zu aktivieren ?"); 
			PrintMini(55,19,"Nein",0);
			PrintMini(55,27,"Ya",0); break;
			case 3:
			DialogueNoShift("Link !  Quieres activar","el nivel de gris?"); 
			PrintMini(55,18,"No",0);
			PrintMini(55,26,"Si",0); break;}
		switch(NivGris)
			{
			case 0: Y=12; break;
			case 1: Y=20; break;
			}
		if(VarA==1)
			{ML_bmp_16_or(Fairy0,X,Y); ML_bmp_16_or(Fairy0,X+68,Y); VarA=0;}
		else
			{ML_bmp_16_or(Fairy1,X,Y); ML_bmp_16_or(Fairy1,X+68,Y); VarA++;}
		ML_display_vram();
		if(key_down(28)&NivGris!=0){NivGris--; while(key_down(28));}
		if(key_down(37)&NivGris!=1){NivGris++; while(key_down(37));}
		}
		Zelda[8]=NivGris;
		
	/*if(!Zelda[8]){while(key_down(78));
	while(!key_down(78))
		{
		setFps(Vitesse*10);
		Clear();
		switch(Zelda[7])
			{case 1:
			DialogueNoShift("Link !","Choisis ta vitesse de marche."); 
			PrintMini(43,10,"Tres Rapide",0);
			PrintMini(52,18,"Rapide",0);
			PrintMini(50,26,"Normal",0);
			PrintMini(55,34,"Lent",0); break;
			case 0:
			DialogueNoShift("Link !","Choose your walking speed."); 
			PrintMini(49,10,"Very Fast",0);
			PrintMini(55,18,"Fast",0);
			PrintMini(50,26,"Normal",0);
			PrintMini(55,34,"Slow",0); break;
			case 2:
			DialogueNoShift("Link ! Wahlen Sie Ihre","Schrittgeschwindigkeit."); 
			PrintMini(41,10,"Sehr Schnell",0);
			PrintMini(50,19,"Schnell",0);
			PrintMini(50,27,"Normal",0);
			PrintMini(48,35,"Langsam",0); break;
			case 3:
			DialogueNoShift("Link !","Elija su velocidad al caminar."); 
			PrintMini(45,10,"Muy Rapido",0);
			PrintMini(52,18,"Rapido",0);
			PrintMini(50,26,"Normal",0);
			PrintMini(53,34,"Lento",0); break;}
		switch(Vitesse)
			{
			case 1: Y=4; break;
			case 2: Y=12; break;
			case 3: Y=20; break;
			case 4: Y=28; break;
			}
		if(VarA==1)
			{ML_bmp_16_or(Fairy0,X,Y); ML_bmp_16_or(Fairy0,X+68,Y); VarA=0;}
		else
			{ML_bmp_16_or(Fairy1,X,Y); ML_bmp_16_or(Fairy1,X+68,Y); VarA++;}
		ML_display_vram();
		if(key_down(28)&Vitesse!=1){Vitesse--; while(key_down(28));}
		if(key_down(37)&Vitesse!=4){Vitesse++; while(key_down(37));}
		}
		Zelda[0]=Vitesse;} else {Zelda[0]=2;}*/
	
	NoShift();
	}

int Tresor(a,b,x)
	{
	extern NumTileset;
	extern int Map[22][30];
	char Random;
	if(MapInf[7]==1){Map[b][a]=50;}
	if(MapInf[7]==2){Map[b][a]=44;}
	Random = Rand(x);
	switch(Random)
		{
		case 1: Map[b][a]=53; break;
		case 2: Map[b][a]=53; break;
		case 3: Map[b][a]=54; break;
		}
	}





